## IdePage IdePage |

## Functions

GtkWidget * | ide_page_new ()
gboolean | ide_page_get_can_split ()
void | ide_page_set_can_split ()
IdePage * | ide_page_create_split ()
const gchar * | ide_page_get_icon_name ()
void | ide_page_set_icon_name ()
GIcon * | ide_page_get_icon ()
void | ide_page_set_icon ()
gboolean | ide_page_get_failed ()
void | ide_page_set_failed ()
const gchar * | ide_page_get_menu_id ()
void | ide_page_set_menu_id ()
gboolean | ide_page_get_modified ()
void | ide_page_set_modified ()
const gchar * | ide_page_get_title ()
void | ide_page_set_title ()
const GdkRGBA * | ide_page_get_primary_color_bg ()
void | ide_page_set_primary_color_bg ()
const GdkRGBA * | ide_page_get_primary_color_fg ()
void | ide_page_set_primary_color_fg ()
void | ide_page_agree_to_close_async ()
gboolean | ide_page_agree_to_close_finish ()
void | ide_page_mark_used ()
void | ide_page_report_error ()

## Properties

gboolean | can-split | Read / Write
gboolean | failed | Read / Write
GIcon * | icon | Read / Write
gchar * | icon-name | Read / Write
gchar * | menu-id | Read / Write
gboolean | modified | Read / Write
GdkRGBA * | primary-color-bg | Read / Write
GdkRGBA * | primary-color-fg | Read / Write
gchar * | title | Read / Write

## Signals

IdePage* | create-split | Run Last

## Types and Values

#define | IDE_TYPE_PAGE
struct | IdePageClass
| IdePage

## Object Hierarchy

        GObject
        ╰── GInitiallyUnowned
            ╰── GtkWidget
                ╰── GtkContainer
                    ╰── GtkBox
                        ╰── IdePage
                            ├── IdeEditorPage
                            ╰── IdeTerminalPage

## Implemented Interfaces

IdePage implements AtkImplementorIface, GtkBuildable and GtkOrientable.

## Description

## Functions

### ide_page_new ()

    GtkWidget *
    ide_page_new (void);

### ide_page_get_can_split ()

    gboolean
    ide_page_get_can_split (IdePage *self);

### ide_page_set_can_split ()

    void
    ide_page_set_can_split (IdePage *self,
                            gboolean can_split);

### ide_page_create_split ()

    IdePage *
    ide_page_create_split (IdePage *self);

This function requests that the IdePage create a split version of itself so that the user may view the document in multiple views.

The view should be added to an IdeLayoutStack where appropriate.

#### Parameters

self | an IdePage |

#### Returns

A newly created IdePage or `NULL`.

[nullable][transfer full]

Since: 3.32

### ide_page_get_icon_name ()

    const gchar *
    ide_page_get_icon_name (IdePage *self);

### ide_page_set_icon_name ()

    void
    ide_page_set_icon_name (IdePage *self,
                            const gchar *icon_name);

### ide_page_get_icon ()

    GIcon *
    ide_page_get_icon (IdePage *self);

Gets the GIcon to represent the view.

#### Parameters

self | a IdePage |

#### Returns

A GIcon or `NULL`.

[transfer none][nullable]

Since: 3.32

### ide_page_set_icon ()

    void
    ide_page_set_icon (IdePage *self,
                       GIcon *icon);

### ide_page_get_failed ()

    gboolean
    ide_page_get_failed (IdePage *self);

### ide_page_set_failed ()

    void
    ide_page_set_failed (IdePage *self,
                         gboolean failed);

### ide_page_get_menu_id ()

    const gchar *
    ide_page_get_menu_id (IdePage *self);

### ide_page_set_menu_id ()

    void
    ide_page_set_menu_id (IdePage *self,
                          const gchar *menu_id);

### ide_page_get_modified ()

    gboolean
    ide_page_get_modified (IdePage *self);

### ide_page_set_modified ()

    void
    ide_page_set_modified (IdePage *self,
                           gboolean modified);

### ide_page_get_title ()

    const gchar *
    ide_page_get_title (IdePage *self);

### ide_page_set_title ()

    void
    ide_page_set_title (IdePage *self,
                        const gchar *title);

### ide_page_get_primary_color_bg ()

    const GdkRGBA *
    ide_page_get_primary_color_bg (IdePage *self);

Gets the “primary-color-bg” property if it has been set.

The primary-color-bg can be used to alter the color of the layout stack header to match the document contents.

#### Parameters

self | a IdePage |

#### Returns

a GdkRGBA or `NULL`.

[transfer none][nullable]

Since: 3.32

### ide_page_set_primary_color_bg ()

    void
    ide_page_set_primary_color_bg (IdePage *self,
                                   const GdkRGBA *primary_color_bg);

Sets the “primary-color-bg” property. If `primary_color_bg` is `NULL`, the property is unset.

#### Parameters

self | a IdePage |
primary_color_bg | a GdkRGBA or `NULL`. | [nullable]

Since: 3.32

### ide_page_get_primary_color_fg ()

    const GdkRGBA *
    ide_page_get_primary_color_fg (IdePage *self);

Gets the “primary-color-fg” property if it has been set.

The primary-color-fg can be used to alter the foreground color of the layout stack header to match the document contents.

#### Parameters

self | a IdePage |

#### Returns

a GdkRGBA or `NULL`.

[transfer none][nullable]

Since: 3.32

### ide_page_set_primary_color_fg ()

    void
    ide_page_set_primary_color_fg (IdePage *self,
                                   const GdkRGBA *primary_color_fg);

Sets the “primary-color-fg” property. If `primary_color_fg` is `NULL`, the property is unset.

#### Parameters

self | a IdePage |
primary_color_fg | a GdkRGBA or `NULL`. | [nullable]

Since: 3.32

### ide_page_agree_to_close_async ()

    void
    ide_page_agree_to_close_async (IdePage *self,
                                   GCancellable *cancellable,
                                   GAsyncReadyCallback callback,
                                   gpointer user_data);

### ide_page_agree_to_close_finish ()

    gboolean
    ide_page_agree_to_close_finish (IdePage *self,
                                    GAsyncResult *result,
                                    GError **error);

### ide_page_mark_used ()

    void
    ide_page_mark_used (IdePage *self);

This function marks the page as used by updating it's position in the workspaces MRU (most-recently-used) queue.

Pages should call this when their contents have been focused.

#### Parameters

self | a IdePage |

Since: 3.32

### ide_page_report_error ()

    void
    ide_page_report_error (IdePage *self,
                           const gchar *format,
                           ...);

This function reports an error to the user in the layout view.

`format` should be a printf-style format string followed by the arguments for the format.

#### Parameters

self | a IdePage |
format | a printf-style format string |

Since: 3.32

## Types and Values

### IDE_TYPE_PAGE

    #define IDE_TYPE_PAGE (ide_page_get_type())

### struct IdePageClass

    struct IdePageClass {
      GtkBoxClass parent_class;

      void           (*agree_to_close_async)  (IdePage              *self,
                                               GCancellable         *cancellable,
                                               GAsyncReadyCallback   callback,
                                               gpointer              user_data);
      gboolean       (*agree_to_close_finish) (IdePage              *self,
                                               GAsyncResult         *result,
                                               GError              **error);
      IdePage       *(*create_split)          (IdePage              *self);
    };

### IdePage

    typedef struct _IdePage IdePage;

## Property Details

### The `“can-split”` property

      “can-split”                gboolean

If the view can be split into a second view.

Owner: IdePage

Flags: Read / Write

Default value: FALSE

### The `“failed”` property

      “failed”                   gboolean

If the view has failed or crashed.

Owner: IdePage

Flags: Read / Write

Default value: FALSE

### The `“icon”` property

      “icon”                     GIcon *

A GIcon for the view.

Owner: IdePage

Flags: Read / Write

### The `“icon-name”` property

      “icon-name”                gchar *

The icon-name describing the view content.

Owner: IdePage

Flags: Read / Write

Default value: "text-x-generic-symbolic"

### The `“menu-id”` property

      “menu-id”                  gchar *

The identifier of the GMenu to use in the document popover.

Owner: IdePage

Flags: Read / Write

Default value: NULL

### The `“modified”` property

      “modified”                 gboolean

If the view has been modified from the saved content.

Owner: IdePage

Flags: Read / Write

Default value: FALSE

### The `“primary-color-bg”` property

      “primary-color-bg”         GdkRGBA *

The "primary-color-bg" property should describe the primary color of the content of the view (if any).

This can be used by the layout stack to alter the color of the header to match that of the content.

Owner: IdePage

Flags: Read / Write

Since: 3.32

### The `“primary-color-fg”` property

      “primary-color-fg”         GdkRGBA *

The "primary-color-fg" property should describe the foreground to use for content above primary-color-bg.

This can be used by the layout stack to alter the color of the foreground to match that of the content.

Owner: IdePage

Flags: Read / Write

Since: 3.32

### The `“title”` property

      “title”                    gchar *

The title of the document or view.

Owner: IdePage

Flags: Read / Write

Default value: NULL

## Signal Details

### The `“create-split”` signal

    IdePage*
    user_function (IdePage *self,
                   gpointer user_data)

This signal is emitted when the view is requested to make a split version of itself. This happens when the user requests that a second version of the file to be displayed, often side-by-side.

This signal will only be emitted when “can-split” is set to `TRUE`. The default is `FALSE`.

#### Parameters

self | an IdePage |
user_data | user data set when the signal handler was connected. |

#### Returns

A newly created IdePage.

[transfer full]

Flags: Run Last

Since: 3.32